///////////////////////////////////////////////////////////////////////////////
//Standardabbildung: Elliptische Fixpunkte mit gegebener Ordnung einzeichnen
//Näherung für letzten KAM-Torus finden
////////////////////////////////////////////////////////////////////////////////

//Bildausschnitt zu Beginn: (Benötigt kein double, da einmalig)
double xU = 0; double xO = 2*Math.PI;
double yU = 0  ; double yO = 2*Math.PI;
 

//Zwischenspeicher:
double  xUNeu, xONeu, yUNeu, yONeu,xAlt, yAlt, xNeu, yNeu;
double   xH1,xH2, yH1,yH2,xH3,yH3,xH4,yH4,xKAM,yKAM; 
PFont font;
int w = 1200; int h = 1200; 
int xK, yK; //Koordinaten der Punkte
int n, i, l, L, M; //Erläuterung im setup()
float f; //für die Farbe
double K;
boolean zeichnen, trajektZeichnen, schonTransparent;
PImage bild;
///////////////////////////////////////////////////////////////////////////


void setup(){ 
  size(1200, 1200);
  background(0); 
  fill(255);
  smooth();
  textSize(16);
  K = 0.971635; //erster Parameter der Map: Rotationszahl ist goldener Schnitt
  strokeWeight(1);
  text("K = "+K, 20, 20);
  n= 100000;  //n...Anzahl der Iterationen
  L =1; //L Zufallsstartpunkte
  l = 0; //zählt die Zufallspunkte
  M = n; //Anzahl der Punkte auf einer ausgewählten Trajektorie
  xUNeu = xU; xONeu = xO;
  yUNeu = yU; yONeu = yO;
  println("K = "+K,"xU = "+xUNeu,"xO = "+xONeu,"yU = "+yUNeu,"yO = "+yONeu);
  XEinhalbZeichnen(); 
  zeichnen = true;
  trajektZeichnen = false;
  schonTransparent = false;
  bild = createImage(w,h,RGB);
 
}
 
 void draw(){//Maps mit variierendem Parameter K zeichnen
   if(zeichnen){
     f=0;
     xH1 = Math.PI;
     yH1 = 2.6130062349415786 ;
     iteriere(xH1,yH1,n,K);//für ?/5  periodisch
     yH1 = 2.6;
     iteriere(xH1,yH1,n,K);//Ellipse um den Fixpunkt - pseudoperiodisch
     
     xH1 = Math.PI;
     yH1 = 2.5228317669380735;
     iteriere(xH1,yH1,n,K);//für ?/8  periodisch
     yH1 = 2.53;
     iteriere(xH1,yH1,n,K);//Ellipse um den Fixpunkt - pseudoperiodisch
     
     xH1 = Math.PI;
     yH1 = 2.5524572808030883;  //für ?/13  periodisch
     iteriere(xH1,yH1,n,K);
     yH1 = 2.55;  //für ?/13 
     iteriere(xH1,yH1,n,K);//Ellipse um den Fixpunkt - pseudoperiodisch
    
     xH1 = Math.PI;
     yH1 =2.5428157918334113;  //für ?/21 periodisch
     iteriere(xH1,yH1,n,K);
     yH1 =2.5420;  //für ?/21 
     iteriere(xH1,yH1,n,K);//Ellipse um den Fixpunkt - pseudoperiodisch
  
     xKAM = 2.6460587978363037;
     yKAM = 2.3103272914886475;
     iteriere(xKAM,yKAM,n,K); 
   
     if(l<L){
      l++;  
     }
       
     if(l>=L && !trajektZeichnen){
       zeichnen = false;        
       tint(255,20);//Bild wird teiltransparent, um die Trajektoerie besser zu sehen
     } 
   }  
   zeichnen = false;
 }
//Aus gegebenem Startpunkt (xH,yH) die folgenden n Punkte berechnen
////////////////////////////////////////////////////////
void iteriere(double xH, double yH, int N ,double K){  
  i=0;
  
  colorMode(HSB,256,256,256); 
  this.K =K;
  xAlt = xH; 
  yAlt = yH;
  point(xK,yK);
  n =   N;
  stroke(color(f%256,255,255)); 
    
  while(i <=n){  
       yNeu = yAlt + K*Math.sin(xAlt); 
       xNeu = (xAlt + yNeu) % (2*Math.PI);
       yK = round( map((float)yNeu,(float)yU,(float)yO,h,0));                 
       xK = round (map((float)xNeu,(float)xU,(float)xO,0,w));  
       point(xK,yK);  //println(xK,yK,i);  
       xAlt = xNeu;
       yAlt = yNeu;
       i++; 
  }
   i=0;  f= f+29; 
  
}

void XEinhalbZeichnen(){
  stroke(255,100); 
  line(w/2,0,w/2,h);
}

/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird 10-fach vergrößert
//////////////////////////////////////////////////////
void mousePressed() { 
  if(mouseButton == LEFT){
      trajektZeichnen = true;
       strokeWeight(1);
      if(!schonTransparent){
        image(bild,0,0);  
        schonTransparent = true;//println("war hier");
      }   
      xH1 = map(mouseX,0,w,(float)xU,(float)xO); 
      yH1 = map(mouseY,0,h, (float)yO,(float)yU);
      println(xH1,yH1);
      f= random(256);
     // M = M + 2000;
      iteriere(xH1,yH1,M,K);
     
      zeichnen = true;
      
     
  }
  if(mouseButton == RIGHT){
     
      trajektZeichnen = false;
      background(0);
     
      xUNeu = map(mouseX,0,w,(float)xU,(float)xO)-(xO-xU)/10;
      xONeu = map(mouseX,0,w,(float)xU,(float)xO)+(xO-xU)/10;
      yUNeu = map(mouseY,0,h, (float)yO,(float)yU)-(yO-yU)/10;
      yONeu = map(mouseY,0,h, (float)yO,(float)yU)+(yO-yU)/10;
      xU =(double) xUNeu; xO =(double) xONeu; yU = (double)yUNeu; yO = (double)yONeu;
      println("xU = "+xUNeu,"xO = "+xONeu,"yU = "+yUNeu,"yO = "+yONeu);
      l=0;
      n = 2*n;
      M=n;
      zeichnen = true;   
  }
  
}
////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

void keyPressed(){
  if(key == '+'){
      trajektZeichnen = false;
      background(0);
      l=0;
      K = K+0.01;
      zeichnen = true;
      println("K = "+K);
  }
    if(key == '-'){
      trajektZeichnen = false;
      background(0);
      l=0;
      K = K-0.01;
      zeichnen = true;
      println("K = "+K);
  }
  if(key == 'k'){
      trajektZeichnen = false;
      background(0);
      l=0;
      XEinhalbZeichnen(); 
      xU = 0;  xO = 1;
      yU = 0 ; yO = 1;
      zeichnen = true;
      println("K = "+K);
  }
  
}

//Verschiedene Punkte (0.5,yH1) zu periodischen Orbits
     
